Subject: Re: [PATCH] net: drop_monitor: use IS_REACHABLE() to guard net_dm_hw_report()

From: Ido Schimmel <[email-masked]>
Date: Wed, 11 Mar 2020 13:28:33 +0200

On Wed, Mar 11, 2020 at 06:47:56AM -0400, Neil Horman wrote:
> On Wed, Mar 11, 2020 at 11:31:43AM +0200, Ido Schimmel wrote:
> > On Wed, Mar 11, 2020 at 03:29:25PM +0900, Masahiro Yamada wrote:
> > > In net/Kconfig, NET_DEVLINK implies NET_DROP_MONITOR.
> > > 
> > > The original behavior of the 'imply' keyword prevents NET_DROP_MONITOR
> > > from being 'm' when NET_DEVLINK=y.
> > > 
> > > With the planned Kconfig change that relaxes the 'imply', the
> > > combination of NET_DEVLINK=y and NET_DROP_MONITOR=m would be allowed.
> > > 
> > > Use IS_REACHABLE() to avoid the vmlinux link error for this case.
> > > 
> > > Reported-by: Stephen Rothwell <[email-masked]>
> > > Signed-off-by: Masahiro Yamada <[email-masked]>
> > 
> > Thanks, Masahiro.
> > 
> > Neil, Jiri, another option (long term) is to add a raw tracepoint (not
> > part of ABI) in devlink and have drop monitor register its probe on it
> > when monitoring.
> > 
> > Two advantages:
> > 1. Consistent with what drop monitor is already doing with kfree_skb()
> > tracepoint
> > 2. We can remove 'imply NET_DROP_MONITOR' altogether
> > 
> > What do you think?
> > 
> Agreed, I think I like this implementation better.

OK, but I don't want to block Masahiro. I think we can go with his patch
and then I'll add the raw tracepoint in the next release.